﻿using System;
using System.IO;
using System.IO.Pipes;

namespace Chapter28_Pipes
{
    class Program
    {
        const string PIPE = "PipeSample";

        static void Main(string[] args)
        {
            if (args.Length == 1)
                Client(args[0]);
            else
                Server();
        }

        private static void Client(string server)
        {
            using (var client = new NamedPipeClientStream(server, PIPE, PipeDirection.In))
            {
                Console.Write("Connecting to {0}... ", server);
                client.Connect();
                Console.WriteLine("Connected");

                using (var reader = new StreamReader(client))
                {
                    var message = reader.ReadLine();
                    Console.WriteLine("Received message: " + message);
                }
            }
        }

        private static void Server()
        {
            using (var server = new NamedPipeServerStream(PIPE, PipeDirection.Out))
            {
                Console.Write("Waiting for connection... ");
                server.WaitForConnection();
                Console.WriteLine("Connected");

                using (var writer = new StreamWriter(server))
                {
                    Console.Write("Enter message: ");
                    var message = Console.ReadLine();
                    writer.WriteLine(message);
                }
            }
        }
    }
}
