﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Chapter31
{
    static class ButtonExtensions
    {
        public static ButtonAwaiter GetAwaiter(this Button button)
        {
            return new ButtonAwaiter(button);
        }

        public sealed class ButtonAwaiter : INotifyCompletion
        {
            private readonly Button _button;

            public ButtonAwaiter(Button button)
            {
                _button = button;
            }

            public bool IsCompleted
            {
                get { return false; }
            }

            public void OnCompleted(Action continuation)
            {
                EventHandler onClick = null;

                onClick = new EventHandler((o, e) =>
                {
                    _button.Click -= onClick;
                    continuation();
                });

                _button.Click += onClick;
            }

            public void GetResult()
            {
            }
        }

    }
}
