﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.Media.Capture;
using Windows.Storage;
using Windows.Storage.Streams;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Media.Imaging;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace Chapter32
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.  The Parameter
        /// property is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
        }

        private async void Button_Click(object sender, RoutedEventArgs e)
        {
            BitmapImage picture = await TakePictureAsync();
            // Left as exercise: render in the UI
        }

        private async Task<BitmapImage> TakePictureAsync()
        {
            CameraCaptureUI cameraUI = new CameraCaptureUI();
            cameraUI.PhotoSettings.AllowCropping = true;
            cameraUI.PhotoSettings.CroppedAspectRatio = new Size(4, 3);
            cameraUI.PhotoSettings.Format = CameraCaptureUIPhotoFormat.Png;

            StorageFile file = await cameraUI.CaptureFileAsync(CameraCaptureUIMode.Photo);
            BitmapImage image = new BitmapImage();
            if (file != null)
            {
                IRandomAccessStream stream = await file.OpenAsync(FileAccessMode.Read);
                await image.SetSourceAsync(stream);
            }

            return image;
        }
    }
}
